// USBMotorDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "PiUsb.h"

// CUSBMotorDlg dialog
class CUSBMotorDlg : public CDialog
{
// Construction
public:

	CUSBMotorDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_USBMOTOR_DIALOG };

	protected:
	// Enum to keep track of motor status.
	// MotorStarted means we have issued a move command, but have not
    // see the Moving bit come on in the device.
    // MotorMoving means we have seen the moving bit come on.
	// Home does not change m_MotorStatus because the Moving bit from
	// the device does not turn on during home.
	enum MotorStatus
	{
		MotorStopped,
		MotorStarted,
		MotorMoving
	};

	MotorStatus m_MotorStatus;
	int		m_MaxSpeed;
	
	BOOL UsbConnected;
	HBITMAP m_GreenLED;
	HBITMAP m_RedLED;
	HBITMAP m_GreyLED;
	int Motor1SerialNum;
	CSpinButtonCtrl	m_VelocitySpin;
	CComboBox		m_MaxCountsCombo;

	// Entries in registry
	CString	m_RegistryKey; 				// Key where settings are stored in registry.
	CString m_RegistryNameSerialNumber;	// Value names
	CString m_RegistryNameVelocity;
	CString m_RegistryNameJogDistance;
	CString m_RegistryNamePosition;
	CString m_RegistryNameUnits;
	CString m_RegistryNameMaxCount;
	enum	{ MAX_TITLE_LENGTH = 100 };

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

	void Disconnect();
	int GetMaxCounts();
	int GetMaxCounts(const CString& s);
	void LimitPosition(int& Position);
	bool CheckVelocity(int Velocity);

public:
	CStatic m_HomeStatus;

	void * pUsb;
	int ErrorNumber;
	GUID HidGuid;
	CStatic m_JogStatus;
	CStatic m_MoveStatus;

	afx_msg void OnCancel();
	afx_msg void OnOK();
	LRESULT Main_OnDeviceChange(WPARAM wParam, LPARAM lParam);
	BOOL RetrieveSettings(void);
	BOOL SaveSettings(void);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButtonJogPlus();
	afx_msg void OnBnClickedButtonJogMinus();
	afx_msg void OnBnClickedMove();
	afx_msg void OnBnClickedHome();
	afx_msg void OnBnClickedHalt();
	void UpdateStatus();
	void RegisterForDeviceNotifications();
	afx_msg void OnBnClickedSave();
	afx_msg void OnBnClickedButtonSetVelocity();
	afx_msg void OnCbnEditchangeComboMaxCounts();
	afx_msg void OnCbnSelchangeComboMaxCounts();
};
